#!/bin/bash

# Database connection parameters
export PGHOST="redshift-host"
export PGDATABASE="database"
export PGPORT=5439
export PGUSER="username"
export PGPASSWORD="password"


# Output file
OUTPUT_FILE="/path/output/sp_ddl_output.sql"

# Query to get view names
QUERY="select database_name ||'.'|| schema_name ||'.'|| function_name ||'('|| replace(replace(replace(replace(replace(argument_type, ' ', ''), 'charactervarying','varchar'),'timestampwithouttimezone','timestamp' ),'binaryvarying', 'varbyte' ),'timestampwithtimezone','timestamptz' ) ||')' from SVV_REDSHIFT_FUNCTIONS where schema_name not in ('information_schema',    'pg_catalog') AND function_type = 'STORED PROCEDURE'"

# Execute the query and save the result in a variable
SPS=$(psql -AXqtc "$QUERY")

# Loop over the views
for SP in $SPS
do
    # Query to get the view definition
    echo "Exporting Procedure DDL: $SP..."
    QUERY="SHOW PROCEDURE "$SP";"

    # Execute the query and save the result in a variable
    SP_DEFINITION=$(psql -AXqtc "$QUERY")

    # Write the view name and its definition to the output file
    echo "-- Stored Procedure: $SP" >> $OUTPUT_FILE
    echo "$SP_DEFINITION" >> $OUTPUT_FILE
    echo "" >> $OUTPUT_FILE
done
